///////////////////////////////////////////////////////////
//////////            TCalc v0.01               ///////////
/////////              By SG57                  ///////////
///////////////////////////////////////////////////////////

#include <pspdisplay.h>
#include <pspctrl.h> 

#include "gfx.h"

extern unsigned long failedNID;

SceCtrlData gpaddata;

#define RGB(r, g, b) ((r)|((g)<<8)|((b)<<16))
#define DARKGREEN  0
#define WHITE      1
#define PINK       2
#define RED        3
#define BLUE       4
#define GREEN      5
#define YELLOW     6
#define CYAN       7
#define GRAY       9
#define DARKBLUE   10
#define DARKRED    11
#define BLACK      12
#define RANDOM     rand()%BLACK

#define true 1
#define false !true
#define bool int

//////////////////////
//// START MACROS ////
//////////////////////
//////////////////////
////  END MACROS  ////
//////////////////////

///////////////////////
//// START GLOBALS ////
///////////////////////
unsigned long foreground;
unsigned long colours[13];
char keys[6][4][4] = {
	{ "C", "sin", "cos", "tan" },
	{ "x/2", "x^2", "sqr", "/" },
	{ "7", "8", "9", "*" },
	{ "4", "5", "6", "-" },
	{ "1", "2", "3", "+" },
	{ "0", "+/-", ".", "=" } 
};

int x;
int y;
char text[30];
int lastNumber;
bool deleteOnKey;
char lastOperation[5];
char value[30];
int number;

bool left, right, up, down, cross;

void InitGlobals()        // use this to declare a variables value
{
     colours[12]= 0x00000000L;
 	colours[1] = 0x00FFFFFFL;
 	colours[2] = 0x00FF00FFL;
 	colours[3] = 0x000000FFL;
 	colours[4] = 0x00FF0000L;
 	colours[5] = 0x0000FF00L;
 	colours[6] = 0x0000FFFFL;
 	colours[7] = 0x00FFFF00L;
 	colours[8] = 0x00FFFF88L;
 	colours[9] = 0x00888888L;
 	colours[0] = 0x00008800L;
     colours[10]= 0x00880000L;
     colours[11]= 0x00000088L;
     
     x = 1;
     y = 1;
     text[0] = '0'; text[1] = '\0';
     lastNumber = 0;
     deleteOnKey = true;
     lastOperation[0] = '\0';
     value[0] = '\0';
     number = 0;
     
     left = false; right = false; up = false; down = false; cross = false;
}

/////////////////////
//// END GLOBALS ////
/////////////////////
extern _start; unsigned long gsp;
void ProcessKeys(unsigned long xikeys)
{
  ////////////////////////
  //// START CONTROLS ////
  ////////////////////////
  if(xikeys & PSP_CTRL_LEFT) {
            if(!left) {
                      playSound(0);
          		  x -= 1;
          		  if (x == 0) {
          				x = 4;
                      }
                      left = true;
            }
  } else { left = false; }
  
  if(xikeys & PSP_CTRL_RIGHT) {
            if(!right) {
                      playSound(0);  
          		  x += 1;
          		  if (x == 5) {
          		  	x = 1;
                      }
                      right = true;
            }
  } else { right = false; }
  
  if(xikeys & PSP_CTRL_UP) {
            if(!up) {
                      playSound(0);
         			  y -= 1;
          		  if (y == 0) {
          		  	y = 6;
                      }
                      up = true;
            }
  } else { up = false; }
  
  if(xikeys & PSP_CTRL_DOWN) {
            if(!down) {
                      playSound(0);
                      y += 1;
 	                 if (y == 7) {
				   y = 1;
                      }
                      down = true;
            }
  } else { down = false; }
  
  if(xikeys & PSP_CTRL_CROSS) {
            if(!cross) {
                    playSound(1);
     			strcpy(value,keys[y-1][x-1]);
     			number = atoi(text);
     			if (strcmp(value,"C")==0) {
                         text[0] = '0'; text[1] = '\0';
     				lastNumber = 0;
     				lastOperation[0] = '\0';
     				deleteOnKey = true;
     			} else if (strcmp(value,"x/2")==0) {
     				itoa_2(number/2,text,10);
     			} else if (strcmp(value,"sin")==0) {
     				itoa_2(sinf(number),text,10);
     			} else if (strcmp(value,"cos")==0) {
     				itoa_2(cosf(number),text,10);
     			} else if (strcmp(value,"tan")==0) {
     				//itoa_2(tanf(number),text,10);
     			} else if (strcmp(value,"x^2")==0) {
     				itoa_2(number*number,text,10);
     			} else if (strcmp(value,"sqr")==0) {
     				itoa_2(sqrtf(number),text,10);
     			} else if ((strcmp(value,"/")==0) || (strcmp(value,"*")==0) || (strcmp(value,"-")==0) || (strcmp(value,"+")==0) || (strcmp(value,"=")==0)) {
     				if (strcmp(lastOperation,"/")==0) {
     					itoa_2(lastNumber / number,text,10);
     				} else if (strcmp(lastOperation,"*")==0) {
     					itoa_2(lastNumber * number,text,10);
    				     } else if (strcmp(lastOperation,"-")==0) {
     					itoa_2(lastNumber - number,text,10);
     				} else if (strcmp(lastOperation,"+")==0) {
     					itoa_2(lastNumber + number,text,10);
     				}
     				number = atoi(text);
     				if (strcmp(value,"=")==0) {
     					itoa_2(number,text,10);
     					lastOperation[0] = '\0';
     				} else {
     					lastNumber = number;
     					strcpy(lastOperation,value);
     				}
     				deleteOnKey = true;
     			} else if (strcmp(value,"+/-")==0) {
     				itoa_2(-number,text,10);
     			} else {
     				if (deleteOnKey) {
     					strcpy(text,value);
     					deleteOnKey = false;
     				} else {
     					strcat(text, value);
     				}
     			}
                    cross=true;
            }          
  } else { cross = false; }
  
  if (xikeys & PSP_CTRL_HOME) // if home is pressed
  {
		   vshKernelExitVSHVSH(NULL);                             // exit
  }
  if(xikeys & PSP_CTRL_NOTE)
  {
            createScreenshot();
  }
  ////////////////////////
  ////  END CONTROLS  ////
  ////////////////////////
}

void main(unsigned long sp)
{  
  gsp = sp;

  InitGlobals();
  initSound();
  initScreenAndCtrl();
  
  fadeIn();
  fadeOut();
  
  int xindex=0,yindex=0;
  
  for(;;) {
     vshCtrlReadBufferPositive(&gpaddata,1);
     ProcessKeys(gpaddata.Buttons);
	Fillvram(RGB(0,0,0));

	for (yindex=0;yindex<6;yindex++) {
		for (xindex=0;xindex<4;xindex++) {
			DrawUnfilledQuadOnScreen(((xindex+1) * 40), ((yindex+1) * 30), 40, 30,colours[GREEN]);
			if (xindex+1 == x && yindex+1 == y) {
				DrawQuadOnScreen(((xindex+1) * 40), ((yindex+1) * 30), 40, 30, RGB(0,255,0));
				foreground = RGB(0,0,0);
			} else {
				foreground = RGB(255,255,255);
			}
			PrintUltraFine(((xindex+1) * 40) + 5, ((yindex+1) * 30) + 5, foreground, keys[yindex][xindex]);
		}
     }
     
    	DrawUnfilledQuadOnScreen(40, 0, 160, 30-2,colours[BLUE]);
	PrintUltraFine(44, 4, colours[CYAN],text);
     
     /*DrawQuadOnScreen(201,0,400,272,RGB(0,0,0)); // hide bug ---  RIGHT
     DrawQuadOnScreen(0,211,400,100,RGB(0,0,0)); // hide bug ---  BOTTOM
     DrawLineOnScreen(250,30,250,210,1,1,RGB(0,255,0)); // hide bug
     DrawLineOnScreen(40,210,250,210,1,1,RGB(0,255,0)); // hide bug*/
     
     PrintUltraFine(316,100,colours[RANDOM],"TCalc v0.01");
     PrintUltraFine(272,115,colours[PINK],"Port / Created by SG57");
     PrintUltraFine(272,150,colours[YELLOW],"Watching out for those");
     PrintUltraFine(284,160,colours[YELLOW],"who need it most...");
     
	changeBuffer();
  }
}
